{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{2003.11.15}
unit plUni;
interface
procedure StrToUnicode(Src,Dst:pointer;Count:dword);
procedure UnicodeToStr(Src,Dst:pointer;Count:dword);
function  UniInit(s:string):boolean;
function  UnicodeNeed(p:pointer;count:dword):boolean;
function  UnicodePresent(p:pointer;count:dword):boolean;
implementation
uses plFile64{,SysUtils},plType;

const TableSize = $80;
      UnicodeTable:array[0..TableSize-1] of word = (
         $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$8F,
         $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F,
         $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,
         $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF,
         $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF,
         $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,
         $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,
         $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF);

var s:string;

procedure StrToUnicode(Src,Dst:pointer;Count:dword);assembler;
asm
        push ecx
        mov  ecx,Count
        jcxz @@Exit2
        cld
        push esi
        push edi
        mov  edi,Dst
        mov  esi,Src
        mov  ebx, offset UnicodeTable
        xor  eax,eax
@@Loop2:
        lodsb
        xor  ah,ah   //  FC = 0 (  xor-)
        rcl  al,1    //    \   
        jnc  @@Next1 //  al   \    
                     //  ASCII (0..127)\   2
        mov  ax,cs:[eax+ebx]
        jmp @@Next2
@@Next1:
        shr  al,1    //    
@@Next2:
        stosw
        loop @@Loop2
        pop  edi
        pop  esi
@@Exit2:
        pop  ecx
end;
procedure UnicodeToStr(Src,Dst:pointer;Count:dword);assembler;
asm
        push ecx
        mov  ecx,Count
        jcxz @@Exit3
        cld
        push esi
        push edi
        mov  edi,Dst
        mov  esi,Src
@@Loop3:
        lodsw
        or   ah,ah
        jz   @@Next3
        push ecx
        push edi
        mov  ecx,TableSize
        mov  edi,Offset UnicodeTable
        repne scasw
        jne  @@Next4
        mov  al,-1
        sub  al,cl
        jmp @@Next5
@@Next4:
        xor  eax,eax
@@Next5:
        pop  edi
        pop  ecx
@@Next3:
        stosb
        loop @@Loop3
        pop  edi
        pop  esi
@@Exit3:
        pop  ecx
end;
function UniInit(s:string):boolean;
var F:longint;
begin
     Result:=false;
     F:=FileOpen(s,fmOpenRead);
     if F<>-1 then begin
        if FileSize(F)>=$100 then
         if FileRead(F,UnicodeTable,$100)<>-1 then
           Result:=true;
        FileClose(F);
     end;
end;
function UnicodeNeed(p:pointer;count:dword):boolean;
var L:dword;
begin
 result:=false;
 if count>0 then begin
  L:=1;
  while(not result)and(L<=count)do begin
   result:=((PAByte(p)^[L] and $80) > 0);
   inc(L);
  end;
 end;
end;
function UnicodePresent(p:pointer;count:dword):boolean;
begin
 result:=(count>0)and {\\}((count and 1)=0)and
  ((PByte(p)^<$22)or(PByte(p+1)^<$22));
end;
begin
     s:=ParamStr(0);
     while(s[byte(s[0])]<>'\')and(s[0]<>#0)do dec(byte(s[0]));
     if(not UniInit(s+'DEFAULT.UNI'))then begin
       s:=ParamStr(0);
       dec(byte(s[0]),3);
       s:=s+'UNI';
       if(not UniInit(s))then
        Writeln('File open error: '+s);
      end;
end.
