{==}


function mdfBaseInitTables(ver:byte;obj:byte):PmdfUnionTables;
begin
 case obj of
 1:begin
    result:=MemAlloc(CmdfUnionTablesObjects);
    if result<>nil then with result^ do begin
     if(ver>80)then begin
      //t_cnt:=3;
      t_cnt:=1;
      //t[1].name:='sysschobjs';
      t[1].t_id:=id_sysschobjs;
      t[1].f_cnt:=4;
      t[1].f[1]:='id';
      t[1].f[2]:='name';
      t[1].f[3]:='type';
      t[1].f[4]:='created';
      {//t[2].name:='sysclsobjs';
      t[2].t_id:=id_sysclsobjs;
      t[2].f_cnt:=4;
      t[2].f[1]:='id';
      t[2].f[2]:='name';
      t[2].f[3]:='type';
      t[2].f[4]:='created';
      //t[2].name:='sysbinobjs';
      t[3].t_id:=id_sysbinobjs;
      t[3].f_cnt:=4;
      t[3].f[1]:='id';
      t[3].f[2]:='name';
      t[3].f[3]:='type';
      t[3].f[4]:='created';}
     end else begin
      t_cnt:=1;
      //t[1].name:='sysobjects';
      t[1].t_id:=id_sysobjects;
      t[1].f_cnt:=4;
      t[1].f[1]:='id';
      t[1].f[2]:='name';
      t[1].f[3]:='xtype';
      t[1].f[4]:='crdate';
     end;
    end;
   end;
 2:begin
    result:=MemAlloc(CmdfUnionTablesColumns);
    if result<>nil then with result^ do begin
     if(ver>80)then begin
      t_cnt:=1;
      //t[1].name:='syscolpars';
      t[1].t_id:=id_syscolpars;
      t[1].f_cnt:=8;
      t[1].f[1]:='id';
      t[1].f[2]:='name';
      t[1].f[3]:='xtype';
      t[1].f[4]:='length';
      t[1].f[5]:='colid';
      // ex
      t[1].f[6]:='utype';
      t[1].f[7]:='prec';
      t[1].f[8]:='scale';
     end else begin
      t_cnt:=1;
      //t[1].name:='syscolumns';
      t[1].t_id:=id_syscolumns;
      t[1].f_cnt:=12;
      t[1].f[1]:='id';
      t[1].f[2]:='name';
      t[1].f[3]:='xtype';
      t[1].f[4]:='length';
      t[1].f[5]:='colid';
      // ex
      t[1].f[6]:='xusertype';
      t[1].f[7]:='xprec';
      t[1].f[8]:='xscale';
      t[1].f[9]:='xoffset';
      t[1].f[10]:='bitpos';
      t[1].f[11]:='typestat';
      t[1].f[12]:='colstat';
     end;
    end;
   end
 else result:=nil;
 end; {case}
end;

procedure mdfBaseClose(var p:PmdfPageStream);
begin
 if p<>nil then with p^ do begin
  if _objects<>nil then MemFree(_objects);
  if _columns<>nil then MemFree(_columns);
  mdfPageClose(p);
 end;
end;
function mdfBaseInit(f:longint;start,size:Int64):PmdfPageStream;
var
 tab:PmdfTable;
 field:word;
begin
 result:=mdfPageOpen(f,start,size);
 if result<>nil then begin
  //write('.1.');
  tab:=mdfInternalTableOpen(result,CmdfPageBoot);
  if(tab<>nil)then begin
   //write('.2.');
   if(mdfTableFirstRow(tab))then begin
    //write('.3.');
    if(mdfTableRowParse(tab)) then begin
     //write('.4.');
     field:=getFieldNumber(tab,'dbi_version');
     if(field>0)and(tab^._field^[field]._pvalue<>nil)then begin
      if PWord(tab^._field^[field]._pvalue)^>$21B then
       result^._version:=90 else result^._version:=80;
     end;
    end;
   end;
   mdfTableClose(tab);
  end;
  {------------------------------------}
  result^._objects:=mdfBaseInitTables(result^._version,1);
  result^._columns:=mdfBaseInitTables(result^._version,2);
  {------------------------------------}
 end;
end;


procedure listObjectsEx(f:longint;start:Int64;size:Int64;mtfPath:string);
var
 tab:PmdfTable;
 pageStream:PmdfPageStream;
 s,s1:string;
 id:dword;
 f1,f2,f3,
 i,j,k:word;
begin
 pageStream:=mdfBaseInit(f,start,size);
 if pageStream=nil then die('Error. Memory allocation error');
 writeln(sZeroTime+' ',mtfPath+'dbinfo.txt');

 for i:=1 to PmdfUnionTables(pageStream^._objects)^.t_cnt do begin
  id:=PmdfUnionTables(pageStream^._objects)^.t[i].t_id;
  tab:=mdfTableOpenEx(pageStream,id,0);
  //writeln('Warning. Table # ',id,'; ver. ',pageStream^._version);
  if tab=nil then writeln('Warning. Can''t open table # ',id,'; ver. ',pageStream^._version)
  else begin

   if(tab^._ex)then begin
    if not mdfTableInitFromTableEx(tab)then begin
     tab^._ex:=false;
     if not mdfTableInitFromTable(tab) then
      mdfSysTablesInitTable(tab,id);
    end;
   end else mdfSysTablesInitTable(tab,id);

   //write('.3.');
   f1:=getFieldNumber(tab,PmdfUnionTables(pageStream^._objects)^.t[i].f[2]);
   f2:=getFieldNumber(tab,PmdfUnionTables(pageStream^._objects)^.t[i].f[3]);
   f3:=getFieldNumber(tab,PmdfUnionTables(pageStream^._objects)^.t[i].f[4]);
   //writeln('f1 = ',f1,' f2 = ',f2,' f3 = ',f3);
   //writeln('f1 = ',PmdfUnionTables(pageStream^._objects)^.t[i].f[2],
   //       ' f2 = ',PmdfUnionTables(pageStream^._objects)^.t[i].f[3],
   //       ' f3 = ',PmdfUnionTables(pageStream^._objects)^.t[i].f[4]);
   if(f1>0)and(f2>0)and(f3>0)and(mdfTableFirstRow(tab))then begin
    //write('.4.');
    repeat
     //write('[0x',HexStr(tab^._page._ph.m_pageId._id,4),':0x',HexStr(tab^._current_row,2),']');

     if((tab^._ex)and(mdfTableRowParseEx(tab)))
      or(mdfTableRowParse(tab))then begin
      {------------------------------------------------------------}
      with tab^ do begin
       if(_field^[f2]._pvalue<>nil)and(not((word(_field^[f2]._pvalue^))in[obj_D]))then begin
        if(_field^[f3]._pvalue<>nil)and(_field^[f3]._size<>0)then begin
         ConvertToSystime(_field^[f3]._pvalue,@sqltime);
         s1:=SystimeToStr(@sqltime,true);
        end else s1:=sZeroTime;
        s1:=s1+' ';
        if(_field^[f1]._pvalue<>nil)and(_field^[f1]._size<>0)then begin
         byte(s[0]):=_field^[f1]._size shr 1;
         UnicodeToStr(_field^[f1]._pvalue,@s[1],byte(s[0]));
         StrToOem(@s[1],@s[1],byte(s[0]));
        end else s:='<NULL>';
        if(_field^[f2]._pvalue<>nil)then
         case word(_field^[f2]._pvalue^) of
         obj_C : write(s1,mtfPath+'check constraints\');
         obj_D : write(s1,mtfPath+'default constraints\');
         obj_F : write(s1,mtfPath+'foreign key constraints\');
         obj_L : write(s1,mtfPath+'logs\');
         obj_FN: write(s1,mtfPath+'scalar functions\');
         obj_IF: write(s1,mtfPath+'inlined table-functions\');
         obj_P : write(s1,mtfPath+'stored procedures\');
         obj_PK: write(s1,mtfPath+'primary key constraints\');
         obj_RF: write(s1,mtfPath+'replication filters\');
         obj_TF: write(s1,mtfPath+'table functions\');
         obj_TR: write(s1,mtfPath+'triggers\');
         obj_UQ: write(s1,mtfPath+'unique constraints\');
         obj_V : write(s1,mtfPath+'views\');
         obj_X : write(s1,mtfPath+'extended stored procedures\');
         obj_S : begin
                  writeln(s1,mtfPath+'system tables\schema\'+s+'.sql');
                  write(s1,mtfPath+'system tables\');
                 end;
         obj_U : begin
                  writeln(s1,mtfPath+'user tables\schema\'+s+'.sql');
                  write(s1,mtfPath+'user tables\');
                 end;
         else  write(s1,mtfPath+asStr(_field^[f2]._pvalue,2)+'\');
         end; {case}
        if(s[byte(s[0])] in [' ','.'])then s:='['+s+']';
        writeln({'0x'+HexStr(longint(_field^[1]._pvalue^),4)+' '+}s);
       end else if(_field^[f2]._pvalue=nil)then writeln(' xtype is NULL');
      end;
      {------------------------------------------------------------}
//      writeln('iam._last = ',tab^._iam^._last);
  //    writeln('iam._lastext = ',tab^._iam^._lastext);
    //  writeln('iam._extent = ',tab^._iam^._extent);
     end else begin
      writeln ('Warning. Can''t parse row [list object]');
      {writeln('iam._last = ',tab^._iam^._last);
      writeln('iam._lastext = ',tab^._iam^._lastext);
      writeln('iam._extent = ',tab^._iam^._extent);
      writeln('_page 00: ',HexStr(@tab^._page._buff[0],16,' ',1,0));
      writeln('_page 10: ',HexStr(@tab^._page._buff[$10],16,' ',1,0));
      writeln('_page 20: ',HexStr(@tab^._page._buff[$20],16,' ',1,0));
      writeln('_page 30: ',HexStr(@tab^._page._buff[$30],16,' ',1,0));
      writeln('_current_row = 0x',HexStr(tab^._current_row,2));}
     end;
    until not mdfTableNextRow(tab);
   end;
   mdfTableClose(tab);
  end;

 end; {for}
 //mdfPageClose(pageStream);
 mdfBaseClose(pageStream);
end;

function getObjIdEx(objname:string;pageStream:PmdfPageStream):dword;
var
 tab:PmdfTable;
 s:string;
 id:dword;
 f1,f2,i:word;

 {p:pointer;
 L:dword;
 j:integer;}

begin
 result:=0;
 for i:=1 to PmdfUnionTables(pageStream^._objects)^.t_cnt do begin
  //writeln('Warning. getObjIdEx ',i);

  {writeln('Warning. Version = ',pageStream^._version);
  writeln('Warning. Objects ID = ',PmdfUnionTables(pageStream^._objects)^.t[1].t_id);
  writeln('Warning. Columns ID = ',PmdfUnionTables(pageStream^._columns)^.t[1].t_id);}

  id:=PmdfUnionTables(pageStream^._objects)^.t[i].t_id;
  tab:=mdfTableOpenEx(pageStream,id,0);
  if tab=nil then writeln('Warning. Can''t open table # ',id,'; ver. ',pageStream^._version)
  else begin
   //writeln('Warning. Start object scan');
   if(tab^._ex)then mdfTableInitFromTableEx2(tab)
   else mdfSysTablesInitTable(tab,id);

   f1:=getFieldNumber(tab,PmdfUnionTables(pageStream^._objects)^.t[i].f[1]);
   f2:=getFieldNumber(tab,PmdfUnionTables(pageStream^._objects)^.t[i].f[2]);

   {with tab^ do for j:=1 to _field_count do begin
    p:=_field^[j]._pname;
    L:=pbyte(p)^;
    inc(p);
    write('"');
    repeat write(EscapeStr(p,L));
    until L=0;
    write('"');
    if j=_field_count then writeln else write('|');
   end;}

   //writeln('Warning. f1 = ',f1,'; f2 = ',f2);readln;

   if(f1>0)and(f2>0)and(mdfTableFirstRow(tab))then begin
    repeat
     //write('[0x',HexStr(tab^._page._ph.m_pageId._id,4),':0x',HexStr(tab^._current_row,2),']');

     if((tab^._ex)and(mdfTableRowParseEx(tab)))
      or(mdfTableRowParse(tab))then begin
      {------------------------------------------------------------}
      with tab^ do begin
       if(_field^[f2]._pvalue<>nil)and(_field^[f2]._size<>0)then begin
        byte(s[0]):=_field^[f2]._size shr 1;
        UnicodeToStr(_field^[f2]._pvalue,@s[1],byte(s[0]));
       end else s:='<NULL>';
       //write(s);
       if(s=objname)and(_field^[f1]._pvalue<>nil)then begin
         result:=dword(_field^[f1]._pvalue^);
         break;
       end;
      end; {with}
      {------------------------------------------------------------}
     end {else writeln ('Warning. Can''t parse row [get objId]')};
    //writeln;
    until not mdfTableNextRow(tab);
   end;
   mdfTableClose(tab);
  end;
  if result<>0 then break;
 end; {for}
 //writeln('Warning. getObjIdEx ended');readln;
end;
{=====================================================================}
function getAllocId(objId:dword;pageStream:PmdfPageStream;var auid:TmdfAllocId):boolean;
begin
 auid._id:=objId;
end;
{=====================================================================}
