{==========================================================}
const field_count_mdf_boot = 52;
{==========================================================}
function init_mdf_boot(p:PmdfTable):PmdfTable;
var q:PmdfTableFields;
    b:boolean;
begin
 if p=nil then begin
  p:=MemAlloc(sizeof(TmdfTable));
  b:=true;
 end else b:=false;
 if p<>nil then begin
  q:=MemAlloc(field_count_mdf_boot*sizeof(TmdfTableField));
  if q<>nil then begin
   with p^ do begin
    _id:=id_allocation;
    _field_count:=field_count_mdf_boot;
    _field:=q;
   end;

   mdfTableFieldInit(q^[1],type_smallint,2,'dbi_version');              {004:word}
   mdfTableFieldInit(q^[2],type_smallint,2,'dbi_createVersion');        {006:word}
   mdfTableFieldInit(q^[3],type_char,10,'dbi_008');                     {008:array [1..10] of byte}
   mdfTableFieldInit(q^[4],type_smallint,2,'dbi_ESVersion');            {012:word}
   mdfTableFieldInit(q^[5],type_int,4,'dbi_014');                       {014:dword}
   mdfTableFieldInit(q^[6],type_int,4,'dbi_018');                       {018:dword}
   mdfTableFieldInit(q^[7],type_bigint,8,'dbi_nextseqnum');             {01C:qword}
   mdfTableFieldInit(q^[8],type_int,4,'dbi_status');                    {024:dword}
   mdfTableFieldInit(q^[9],type_int,4,'dbi_nextid');                    {028::dword}
   mdfTableFieldInit(q^[10],type_datetime,8,'dbi_crdate');              {02C:qword}
   mdfTableFieldInit(q^[11],type_nchar,256,'dbi_dbname');               {034:array[0..255]of byte}
   mdfTableFieldInit(q^[12],type_int,4,'dbi_dbnamelen');                {134:dword}
   mdfTableFieldInit(q^[13],type_smallint,2,'dbi_dbid');                {138:word}
   mdfTableFieldInit(q^[14],type_tinyint,1,'dbi_compLevel');            {13A:byte}
   mdfTableFieldInit(q^[15],type_tinyint,1,'dbi_masterFixups');         {13B:byte}
   mdfTableFieldInit(q^[16],type_datetime,8,'dbi_maxDbTimestamp');      {13C:qword}
   mdfTableFieldInit(q^[17],type_char,10,'dbi_differentialBaseLSN');    {144:TmdfPageLSN}
   mdfTableFieldInit(q^[18],type_smallint,2,'dbi_14E');                 {14E:word}
   mdfTableFieldInit(q^[19],type_char,10,'dbi_createIndexLSN');         {150:TmdfPageLSN}
   mdfTableFieldInit(q^[20],type_smallint,2,'dbi_15A');                 {15A:word}
   mdfTableFieldInit(q^[21],type_char,10,'dbi_checkptLSN');             {15C:TmdfPageLSN}
   mdfTableFieldInit(q^[22],type_smallint,2,'dbi_dataPurity');          {166:word}
   mdfTableFieldInit(q^[23],type_char,10,'dbi_168');                    {168:TmdfPageLSN}
   mdfTableFieldInit(q^[24],type_smallint,2,'dbi_172');                 {172:word}
   mdfTableFieldInit(q^[25],type_char,10,'dbi_174');                    {174:TmdfPageLSN}
   mdfTableFieldInit(q^[26],type_smallint,2,'dbi_17E');                 {17E:word}
   mdfTableFieldInit(q^[27],type_char,6,'dbi_maxXdesId');               {180:TmdfPageId}
   mdfTableFieldInit(q^[28],type_tinyint,1,'dbi_sortOrder');            {186:byte}
   mdfTableFieldInit(q^[29],type_tinyint,1,'dbi_187');                  {187:byte}
   mdfTableFieldInit(q^[30],type_int,4,'dbi_collation');                {188:dword}
   mdfTableFieldInit(q^[31],type_int,4,'dbi_compareFlag');              {18C:dword}
   mdfTableFieldInit(q^[32],type_int,4,'dbi_relStat');                  {190:dword}
   mdfTableFieldInit(q^[33],type_int,4,'dbi_filegeneration');           {194:dword}
   mdfTableFieldInit(q^[34],type_char,16,'dbi_familyGUID');             {198:GUID}
   mdfTableFieldInit(q^[35],type_bigint,8,'dbi_maxLogSpaceUsed');       {1A8:qword}
   mdfTableFieldInit(q^[36],type_char,6,'dbi_oldestBackupXactLSN');     {1B0:TmdfPageId}
   mdfTableFieldInit(q^[37],type_smallint,2,'dbi_1BA');                 {1BA:word}
   mdfTableFieldInit(q^[38],type_char,56,'dbi_recoveryForkNameStack');  {1BC:TMdfForkStack}
   mdfTableFieldInit(q^[39],type_char,16,'dbi_differentialBaseGuid');   {1F4:GUID}
   mdfTableFieldInit(q^[40],type_char,6,'dbi_204');                     {204:TMdfPageId}
   mdfTableFieldInit(q^[41],type_smallint,2,'dbi_20A');                 {20A:word}
   mdfTableFieldInit(q^[42],type_char,10,'dbi_versionChangeLSN');       {20C:TmdfPageLSN;}
   mdfTableFieldInit(q^[43],type_smallint,2,'dbi_216');                 {216:word}
   mdfTableFieldInit(q^[44],type_char,10,'dbi_218');                    {218:TmdfPageLSN;}
   mdfTableFieldInit(q^[45],type_smallint,2,'dbi_222');                 {222:word}
   mdfTableFieldInit(q^[46],type_int,4,'dbi_category');                 {224:dword}
   mdfTableFieldInit(q^[47],type_char,64,'dbi_228');                    {228:??}
   mdfTableFieldInit(q^[48],type_datetime,8,'dbi_lastKnownGoodCheckDB');{28C:qword}
   mdfTableFieldInit(q^[49],type_char,16,'dbi_294');                    {294:??}
   mdfTableFieldInit(q^[50],type_datetime,8,'dbi_lastKnownGoodCheckDB');{2A4:qword}
   mdfTableFieldInit(q^[51],type_int,4,'dbi_2AC');                      {2AC:??}
   mdfTableFieldInit(q^[52],type_int,4,'dbi_binfoLazyCommitState');     {2B0:dword}
   
{ 166: dw DataPurity
 186: db dbi_sortOrder
 187: db ?? language ??
 18C: dd dbi_compareFlag
 28C: dq LastKnownGoodCheckDBDate
 2A4: dq LastModification
 2B0: dd DbinfoLazyCommitState
 2D9: db RmidRegDeleted (1 or 0)}

  end else if b then MemFree(p);
 end;
 result:=p;
end;
{==========================================================}


