{==========================================================}
const field_count_syscolpars = 16;
{==========================================================}
function init_syscolpars(p:PmdfTable):PmdfTable;
var q:PmdfTableFields;
    b:boolean;
begin
 if p=nil then begin
  p:=MemAlloc(sizeof(TmdfTable));
  b:=true;
 end else b:=false;
 if p<>nil then begin
  q:=MemAlloc(field_count_syscolpars*sizeof(TmdfTableField));
  if q<>nil then begin
   with p^ do begin
    _id:=id_syscolpars;
    _field_count:=field_count_syscolpars;
    _field:=q;
   end;

   mdfTableFieldInit(q^[1],type_int,4,'id');
   mdfTableFieldInit(q^[2],type_smallint,2,'number');
   mdfTableFieldInit(q^[3],type_int,4,'colid');
   mdfTableFieldInit(q^[4],type_sysname,$100,'name');
   mdfTableFieldInit(q^[5],type_tinyint,1,'xtype');
   mdfTableFieldInit(q^[6],type_int,4,'utype');
   mdfTableFieldInit(q^[7],type_smallint,2,'length');
   mdfTableFieldInit(q^[8],type_tinyint,1,'prec');
   mdfTableFieldInit(q^[9],type_tinyint,1,'scale');
   mdfTableFieldInit(q^[10],type_int,4,'collationid');
   mdfTableFieldInit(q^[11],type_int,4,'status');
   mdfTableFieldInit(q^[12],type_smallint,2,'maxinrow');
   mdfTableFieldInit(q^[13],type_int,4,'xmlns');
   mdfTableFieldInit(q^[14],type_int,4,'dflt');
   mdfTableFieldInit(q^[15],type_int,4,'chk');
   mdfTableFieldInit(q^[16],type_varbinary,64,'idtval');

  end else if b then MemFree(p);
 end;
 result:=p;
end;
{==========================================================}
