{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{2005.02.22 - MemScan rewrite}
{2003.11.15}
unit plMem;
interface
function MemAlloc(Size:dword):pointer;
{ 뤥  }
procedure MemFree(var p:pointer);
{ ᢮  }
procedure MemCopy(Src,Dst:pointer;Count:dword);stdcall;
{    Src  Dst }
procedure MemSet(p:pointer;Count:dword;C:byte);stdcall;
{   㪠 ⮬ }
function  MemCmp(Src,Dst:pointer;Size:dword):dword;stdcall;
{ ࠢ   Src  Dst
  頥   (稭  1),  ண  ࠧ
   0, ᫨   }
function  MemScan(Size1:dword;Src:pointer;Size2:dword;Dst:pointer):dword;stdcall;
implementation
function MemAlloc(size:dword):pointer;
begin
 if(size>0){and(size<=MemAvail)}then begin
  GetMem(result,size);
  if result<>nil then MemSet(result,size,0);
 end else result:=nil;
end;
procedure MemFree(var p:pointer);
begin if p<>nil then begin FreeMem(p);p:=nil end end;
procedure MemCopy(Src,Dst:pointer;Count:dword);assembler;stdcall;
asm
        push ecx
        mov  ecx,Count
        jcxz @@MC_exit
        cld
        push esi
        push edi
        mov  esi,Src
        mov  edi,Dst
        cmp  esi,edi
        jz   @@MC_exit1
        ja   @@MC_a
@@MC_b:
        add  edi,ecx
        dec  edi
        add  esi,ecx
        dec  esi
        std
@@MC_a:
        repe movsb
@@MC_exit1:
        pop  edi
        pop  esi
@@MC_exit:
        pop  ecx
end;

procedure MemSet(p:pointer;Count:dword;C:byte);assembler;stdcall;
asm
        push ecx
        push edi
        mov  edi,p
        mov  ecx,Count
        mov  al,C
        mov  ah,al
        cld
        test edi,1
        je   @@MS_1
        jcxz @@MS_2
        stosb
        dec  ecx
@@MS_1:
        shr  ecx,1
        repe stosw
        jae  @@MS_2
        stosb
@@MS_2:
        pop  edi
        pop  ecx
end;

function  MemCmp(Src,Dst:pointer;Size:dword):dword;assembler;stdcall;
asm
        push ecx
        push esi
        push edi
        xor  eax,eax
        mov  ecx,Size
        jcxz @@MCMP_exit
        mov  esi,Src
        mov  edi,Dst
        cld
        repe cmpsb
        dec  esi
        mov  ecx,eax
        dec  edi
        mov  al,byte ptr [esi]
        mov  cl,byte ptr [edi]
        sub  eax,ecx
@@MCMP_exit:
        pop  edi
        pop  esi
        pop  ecx
end;

function  MemScan(Size1:dword;Src:pointer;Size2:dword;Dst:pointer):dword;assembler;stdcall;
asm
        pushf
        push ebx
        push ecx
        push edx
        push esi
        push edi
        cld
        mov  ebx,Size2
        mov  edx,Size1
        sub  ebx,edx
        ja   @@MS_next
@@MS_error:
        xor  eax,eax
        jmp  @@MS_exit
@@MS_next:
        mov  eax,dst
        inc  ebx
@@MS_loop:
        mov  esi,src
        mov  ecx,ebx
        mov  edi,eax
        lodsb
        repne scasb
        jnz  @@MS_error
        mov  eax,edi
        mov  ebx,ecx
        mov  ecx,edx
        dec  ecx
        repe cmpsb
        jnz  @@MS_loop
        sub  eax,dst
@@MS_exit:
        dec  eax
        pop  edi
        pop  esi
        pop  edx
        pop  ecx
        pop  ebx
        popf
end;

end.
