{==========================================================}
type

 TMdfLsn = packed record
           d1,d2:dword;
           w1:word;
 end; {TMdfLsn}

 PMdfForkStack = ^TMdfForkStack;
 TMdfForkStack = packed record
                 _lsn:TMdfLsn;
                 _w:word;
                 _guid:GUID;
                 _data:array [0..27] of byte; 
 end; {TMdfForkStack}

 PMdfBoot = ^TMdfBoot;
 TMdfBoot = packed record

     {000:} dbi_slotHeader:word;
     {002:} dbi_dataSize:word;
     {004:} dbi_version:word;
     {006:} dbi_createVersion:word;
     {008:} dbi_008:array [1..10] of byte;
     {012:} dbi_ESVersion:word;
     {014:} dbi_014:dword;
     {018:} dbi_018:dword;
     {01C:} dbi_nextseqnum:qword;
     {024:} dbi_status:dword;
     {028:} dbi_nextid:dword;
     {02C:} dbi_crdate:qword;
     {034:} dbi_dbname:array[0..255]of byte;
     {134:} dbi_dbnamelen:dword;
     {138:} dbi_dbid:word;
     {13A:} dbi_compLevel:byte;
     {13B:} dbi_masterFixups:byte;
     {13C:} dbi_maxDbTimestamp:qword;
     {144:} dbi_differentialBaseLSN:TmdfPageLSN;
     {14E:} dbi_14E:word;
     {150:} dbi_createIndexLSN:TmdfPageLSN;
     {15A:} dbi_15A:word;
     {15C:} dbi_checkptLSN:TmdfPageLSN;
     {166:} dbi_166:word;
     {168:} dbi_168:TmdfPageLSN;
     {172:} dbi_172:word;
     {174:} dbi_174:TmdfPageLSN;
     {17E:} dbi_17E:word;
     {180:} dbi_maxXdesId:TmdfPageId;
     {186:} dbi_186:byte;
     {187:} dbi_187:byte;
     {188:} dbi_collation:dword;
     {18C:} dbi_18C:dword;
     {190:} dbi_relStat:dword;
     {194:} dbi_filegeneration:dword;
     {198:} dbi_familyGUID:GUID;
     {1A8:} dbi_maxLogSpaceUsed:qword;
     {1B0:} dbi_oldestBackupXactLSN:TmdfPageId;
     {1BA:} dbi_1BA:word;
     {1BC:} dbi_recoveryForkNameStack:TMdfForkStack;
     {1F4:} dbi_differentialBaseGuid:GUID;
     {204:} dbi_204:TMdfPageId;
     {20A:} dbi_20A:word;
     {20C:} dbi_versionChangeLSN:TMdfLsn;
     {216:} dbi_216:word;
     {218:} dbi_218:TMdfLsn;
     {222:} dbi_222:word;
     {224:} dbi_category:dword;

 end; {TMdfBoot}

{==========================================================}
const field_count_mdf_boot = 1;
{==========================================================}
function init_mdf_boot(p:PmdfTable):PmdfTable;
var q:PmdfTableFields;
    b:boolean;
begin
 if p=nil then begin
  p:=MemAlloc(sizeof(TmdfTable));
  b:=true;
 end else b:=false;
 if p<>nil then begin
  q:=MemAlloc(field_count_mdf_boot*sizeof(TmdfTableField));
  if q<>nil then begin
   with p^ do begin
    _id:=id_allocation;
    _field_count:=field_count_mdf_boot;
    _field:=q;
   end;

   mdfTableFieldInit(q^[1],type_char,$228,'DATA');

  end else if b then MemFree(p);
 end;
 result:=p;
end;
{==========================================================}


