{==========================================================}
const field_count_mdf_header = 29;
{==========================================================}
function init_mdf_header(p:PmdfTable):PmdfTable;
var q:PmdfTableFields;
    b:boolean;
begin
 if p=nil then begin
  p:=MemAlloc(sizeof(TmdfTable));
  b:=true;
 end else b:=false;
 if p<>nil then begin
  q:=MemAlloc(field_count_mdf_header*sizeof(TmdfTableField));
  if q<>nil then begin
   with p^ do begin
    _id:=id_allocation;
    _field_count:=field_count_mdf_header;
    _field:=q;
   end;

   mdfTableFieldInit(q^[1],type_varbinary,16,'BindingID');
   mdfTableFieldInit(q^[2],type_varbinary,255,'UnknownField2');
   mdfTableFieldInit(q^[3],type_varbinary,2,'FileIdProp');
   mdfTableFieldInit(q^[4],type_varbinary,2,'FileGroupId');
   mdfTableFieldInit(q^[5],type_varbinary,4,'Size');
   mdfTableFieldInit(q^[6],type_varbinary,4,'MaxSize');
   mdfTableFieldInit(q^[7],type_varbinary,4,'Growth');
   mdfTableFieldInit(q^[8],type_varbinary,4,'Perf');
   mdfTableFieldInit(q^[9],type_varbinary,10,'BackupLsn');
   mdfTableFieldInit(q^[10],type_varbinary,10,'FirstUpdateLsn');
   mdfTableFieldInit(q^[11],type_varbinary,10,'FirstCreateIndexLsn');
   mdfTableFieldInit(q^[12],type_varbinary,10,'FirstNonloggedUpdateLsn');
   mdfTableFieldInit(q^[13],type_varbinary,4,'MinSize');
   mdfTableFieldInit(q^[14],type_varbinary,4,'Status');
   mdfTableFieldInit(q^[15],type_varbinary,4,'UserShrinkSize');
   mdfTableFieldInit(q^[16],type_varbinary,4,'SectorSize');
   mdfTableFieldInit(q^[17],type_varbinary,10,'MaxLsn');
   mdfTableFieldInit(q^[18],type_varbinary,28,'RecoveryForkName');
   mdfTableFieldInit(q^[19],type_varbinary,10,'FirstLsn');
   // 8.0
   mdfTableFieldInit(q^[20],type_varbinary,10,'CreateLsn');
   mdfTableFieldInit(q^[21],type_varbinary,10,'DifferentialBaseLsn');
   mdfTableFieldInit(q^[22],type_varbinary,16,'DifferentialBaseGuid');
   // 9.0
   mdfTableFieldInit(q^[23],type_varbinary,10,'UnknownField23');
   mdfTableFieldInit(q^[24],type_varbinary,16,'UnknownField24');
   mdfTableFieldInit(q^[25],type_varbinary,4,'UnknownField25');
   mdfTableFieldInit(q^[26],type_varbinary,10,'UnknownField26');
   mdfTableFieldInit(q^[27],type_varbinary,255,'UnknownField27');
   mdfTableFieldInit(q^[28],type_nvarchar,255,'UnknownField28');
   mdfTableFieldInit(q^[29],type_varbinary,16,'UnknownField29');

  end else if b then MemFree(p);
 end;
 result:=p;
end;
{==========================================================}


